use backtrack::{BackTracker, Reine};

pub fn nb_blocked_lines(n: usize, to_put: Reine, put: &BackTracker) -> usize {
  let row = to_put.0 + 1;

  let mut blocked: Vec<i32> = Vec::new();

  blocked.append(&mut blocked_columns(row, &to_put));

  for reine in put {
    let cols = blocked_columns(row, reine);

    //only add columns that aren't
    //already in blocked
    for col in cols {
      if !blocked.contains(&col) {
        blocked.push(col);
      }
    }
  }

  return blocked
    .iter()
    .filter(|c| **c >= 0 && **c < n as i32)
    .count();
}

fn blocked_columns(row: i32, reine: &Reine) -> Vec<i32> {
  let row_diff = (row - reine.0).abs();
  vec![reine.1 - row_diff, reine.1, reine.1 + row_diff]
}